package com.gic.cloud.data.hook.service;

import com.ctrip.framework.apollo.Config;
import com.ctrip.framework.apollo.ConfigService;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.concurrent.BasicThreadFactory;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

@Component
public class FilterFieldUtils {
    /** 脱敏字段 */
    public static List<String> FILTERS_PHONE_ONLY = Arrays.asList("mobile", "phone", "enterprise_name", "phone_number", "receive_phone_number", "use_phone_number", "friend_phone_num","from_phone_num");

    /** 脱敏字段 */
    public static List<String> FILTERS_PHONE_AND_CARD = Arrays.asList("card_num", "mobile", "phone", "enterprise_name", "phone_number", "receive_phone_number","receive_card_num","use_phone_number", "use_card_num","friend_card_num","from_card_num", "friend_phone_num","from_phone_num");

    public static List<String> FILETERS_USER_NAME = Arrays.asList("member_name","children_name","mbr_name","receive_member_name","use_member_name","name","bb_name","friend_mbr_name","from_mbr_name");

    ScheduledExecutorService timer = new ScheduledThreadPoolExecutor(1,
            new BasicThreadFactory.Builder().namingPattern("loadFilterFieldTimer-%d").daemon(true).build());

    @PostConstruct
    public void init(){
        System.out.println("初始化加密字段");
        Config config = ConfigService.getConfig("application");
        String phoneNumberField = config.getProperty("phoneNumberField", "");
        String cardNumField = config.getProperty("cardNumField", "");
        String userNameField = config.getProperty("userNameField", "");
        if(StringUtils.isNotBlank(phoneNumberField)){
            FILTERS_PHONE_ONLY = Arrays.asList(phoneNumberField.split(","));
            FILTERS_PHONE_AND_CARD = new ArrayList<>();
            for(String s : phoneNumberField.split(",")){
                FILTERS_PHONE_AND_CARD.add(s);
            }
        }
        if(StringUtils.isNotBlank(cardNumField)){
            for(String s : cardNumField.split(",")){
                FILTERS_PHONE_AND_CARD.add(s);
            }
        }
        if(StringUtils.isNotBlank(userNameField)){
            FILETERS_USER_NAME = Arrays.asList(userNameField.split(","));
        }
        initTimer();
    }

    private void initTimer(){
        timer.scheduleAtFixedRate(new Runnable() {
            @Override
            public void run() {
                System.out.println("更新定时器");
                init();
            }
        }, 5, 5, TimeUnit.MINUTES);
    }
}
